package io.gitlab.jfronny.dynres;

import io.gitlab.jfronny.libjf.web.api.WebInit;
import io.gitlab.jfronny.libjf.web.api.WebServer;
import net.fabricmc.api.EnvType;
import net.fabricmc.loader.api.FabricLoader;
import net.fabricmc.loader.impl.gui.FabricGuiEntry;
import org.apache.logging.log4j.LogManager;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

public class DynRes implements WebInit {
    public static final org.apache.logging.log4j.Logger LOGGER = LogManager.getLogger("DynRes");
    public static File resFile;
    public static String resourceLink = "";

    static {
        resFile = new File(FabricLoader.getInstance().getGameDir().toFile(), Cfg.resourcesFile);
        if (!resFile.isFile()) {
            FabricGuiEntry.displayCriticalError(new FileNotFoundException("The file " + resFile + " does not exist in the game directory but is required"), true);
        }
    }

    @Override
    public void register(WebServer api) {
        if (FabricLoader.getInstance().getEnvironmentType() == EnvType.SERVER) {
            try {
                resourceLink = api.registerFile("/resources.zip", resFile.toPath(), !Cfg.hashResources);
                LOGGER.info("Initialized DynRes at " + resourceLink);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
